SystemOrganization addCategory: #'Phidget-Mock'!
SystemOrganization addCategory: #'Phidget-Mock-Tests'!

CsComposition subclass: #PhdMkPhidgetLayer
	instanceVariableNames: 'phidgets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

PhdMkPhidgetLayer subclass: #PhdMkInterfaceKitLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkInterfaceKitLayer class methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 13:01'!
computeLayers
	^ { PhdMkInterfaceKitLayer new }! !

!PhdMkInterfaceKitLayer methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 12:41'!
mockClass
	^ PhdMkInterfaceKitData! !

!PhdMkInterfaceKitLayer methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 12:43'!
variedPhidgetClass
	^ PhdCrInterfaceKit class! !

!PhdMkPhidgetLayer class methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 13:01'!
computeLayers
	^ self subclassResponsibility! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 10:33'!
addMock: aMock

	aMock id: self nextPhidgetId.
	phidgets add: aMock.! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/22/2009 12:44'!
advicePrimGetNewId
"primGetNewId"
	"Create a new the Interface Kit object. Returns a new id for the Phidget, or nil if there was an error."
	
	^ CsAroundVariation
		target: [ self variedPhidgetClass -> #primGetNewId ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod |
			| mock |
			mock := self mockClass new: self.
			mock id
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/22/2009 13:48'!
advicePrimIsValid
"primIsValid: phidgetidArray"
	"Returns 1 if the Phidget id is valid, or other values otherwise."
	
	^ CsAroundVariation
		target: [ self variedPhidgetClass -> #primIsValid: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod |
			(phidgets values contains: [:each | each id = (arguments at: 1)])
				ifTrue: [ 1 ]
				ifFalse: [ nil ]
		]! !

!PhdMkPhidgetLayer methodsFor: 'primitives' stamp: 'lk 11/22/2009 14:29'!
advicePrimOpenWithSerial
"primOpen: phidgetidArray withSerial: serial"
	"Opens the Phidget with the given serial number.
	Return 1 if the operation succeeded, or other values otherwise."

	^ CsAroundVariation
		target: [ self variedPhidgetClass -> #primOpen:withSerial: ]
		aroundBlock: [ :receiver :arguments :layer :client :clientMethod |
			| mock |
			mock := layer phidgetFromId: (arguments at: 1).
			mock open: true.
			mock serialNumber: (arguments at: 2).
			1
		]! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 11:14'!
assureUniqueId: aPhidgetId
	| max |
	max := self phidgets size = 0
		ifTrue: [ TimeStamp new ]
		ifFalse: [ (self phidgets collectValues: [ :each | each id ]) max ].
	^ aPhidgetId > max
		ifTrue: [ aPhidgetId ]
		ifFalse: [ max + 1 ]! !

!PhdMkPhidgetLayer methodsFor: 'initialization' stamp: 'lk 11/21/2009 18:59'!
initialize
	super initialize.
	
	phidgets := PhdMkLinkedList new.! !

!PhdMkPhidgetLayer methodsFor: 'polymorph class names' stamp: 'lk 11/22/2009 12:39'!
mockClass
	^ self subclassResponsibility! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 10:23'!
nextPhidgetId
	| now |
	now := TimeStamp now.
	^ self assureUniqueId: now.! !

!PhdMkPhidgetLayer methodsFor: 'phidgets list' stamp: 'lk 11/22/2009 14:24'!
phidgetFromId: phidgetId
	^ phidgets values detect: [ :each | each id = phidgetId ]! !

!PhdMkPhidgetLayer methodsFor: 'accessing' stamp: 'lk 11/21/2009 19:15'!
phidgets
	^ phidgets! !

!PhdMkPhidgetLayer methodsFor: 'polymorph class names' stamp: 'lk 11/22/2009 12:43'!
variedPhidgetClass
	^ self subclassResponsibility! !

LinkedList subclass: #PhdMkLinkedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 20:02'!
addLast: value
	|item|
	item := PhdMkLinkedListItem new: value.
	super addLast: item.! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:16'!
collectValues: aBlock
	| values |
	values := self collect: [ :each | each value ].
	^ values collect: aBlock! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:33'!
itemsUnique: aBlock
	| items |	
	items := self collectValues: aBlock.
	
	^ items size > 0
		ifTrue: [ (items contains: [ :each |
			"if more than one item was removed in copyWithout, this item is not unique"
			(items copyWithout: each) size ~= (items size - 1) ]) not
		] ifFalse: [ true ]! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 20:03'!
valueAt: index
	| item |
	item := self at: index.
	^ item value! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 20:03'!
valueAt: index ifAbsent: aBlock
	| item |
	item := self at: index ifAbsent: aBlock.
	^ item
		ifNil: [ nil ]
		ifNotNil: [ item value ]! !

!PhdMkLinkedList methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 12:34'!
values
	^ self collect: [ :each | each value ]! !

Object subclass: #PhdMkLinkedListItem
	instanceVariableNames: 'nextLink value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkLinkedListItem class methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:04'!
new: value

	^ self new
		value: value! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:02'!
nextLink
	^ nextLink! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:01'!
nextLink: newNextLink
	nextLink := newNextLink.! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:00'!
value
	^ value! !

!PhdMkLinkedListItem methodsFor: 'as yet unclassified' stamp: 'lk 11/21/2009 19:00'!
value: newValue
	value := newValue.! !

Object subclass: #PhdMkPhidgetData
	instanceVariableNames: 'id serialNumber open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

PhdMkPhidgetData subclass: #PhdMkInterfaceKitData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock'!

!PhdMkPhidgetData class methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 10:31'!
new: aMockLayer

	| instance |
	instance := self new.
	aMockLayer addMock: instance.
	^ instance
	! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 10:51'!
id
	^ id! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 10:51'!
id: newId
	id := newId.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:30'!
open
	^ open! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:30'!
open: aBoolean
	open := aBoolean.! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:21'!
serialNumber
	^ serialNumber! !

!PhdMkPhidgetData methodsFor: 'accessing' stamp: 'lk 11/22/2009 14:30'!
serialNumber: anInteger
	serialNumber := anInteger.! !

TestCase subclass: #PhdMkInterfaceKitLayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock-Tests'!

!PhdMkInterfaceKitLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 13:02'!
testComputeLayers
	| layers layerClasses |
	layers := PhdMkInterfaceKitLayer computeLayers.
	layerClasses := layers collect: [:each | each class].
	self assert: ( layerClasses includesAllOf: { PhdMkInterfaceKitLayer } ).! !

TestCase subclass: #PhdMkPhidgetLayerTest
	instanceVariableNames: 'layer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-Mock-Tests'!

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:43'!
layerClass
	^ PhdMkInterfaceKitLayer! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:44'!
phidgetClass
	^ PhdCrInterfaceKit! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:44'!
setUp

	layer := self layerClass new.! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 12:36'!
testPhidgetsList
	
	| phidget |
	self assert: layer phidgets size = 0.
	[{layer}] useAsLayersFor: [
		phidget := self phidgetClass new.
		self phidgetClass new.
		self phidgetClass new.
	].
	self assert: layer phidgets size = 3.
	self assert: (layer phidgets values contains: [ :each | each id = phidget id ])! !

!PhdMkPhidgetLayerTest methodsFor: 'as yet unclassified' stamp: 'lk 11/22/2009 11:44'!
testUniqueIds

	[{layer}] useAsLayersFor: [
		self phidgetClass new.
		self phidgetClass new.
		self phidgetClass new.
	].
	self assert: (layer phidgets itemsUnique: [ :each | each id ]).! !
